using DataFrames,StatsBase

##零模型1
#  思想时设定基本的作用强度
#  约束条件为物种数量不变，Connectance不变
"""
`Null1(data::DataFrame)`\n
Null model 1, the constraint condition is that the number of species remains unchanged and the connectivity remains unchanged.\n
# Argument\n
* `data`:The adjacency matrix of a bipartite network.\n
# Return\n
* `nulldata`:Dataframe generated by null model 1.\n
# Example\n
using BipartiteNull,DataFrames;\n
data=ExampleData(7);\n
print(data);\n
nulldata=Null1(data)
"""
function Null1(data::DataFrame)
#  转化为矩阵
  matrix_origin=Matrix(data[:,Not(1)])
#  获取矩阵尺寸
  a,b=size(matrix_origin)
#  重组向量为1维
  v_origin=reshape(matrix_origin,(a*b))
#  打乱向量顺序
  v_null=SampleVector(v_origin)
#  转化为空模型的矩阵
  matrix_null=reshape(v_null,(a,b))
#  转化为数据框
  nulldata=hcat(DataFrame(AdjacencyMatrix=data[:,1]),DataFrame(matrix_null,:auto))
  rename!(nulldata,propertynames(data))
#  返回数据
  return(nulldata)
end